#!/usr/bin/perl
##############################################################################
# Megabook - Guestbook ADMINISTRATION Script V1.1                            # 
# Copyright 2000 Terry Billinger                                             #
# Created 7/3/00                                                             #
# Available at http://www.militerry.com/megabook/                            #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 Terry Billinger                                             #
#    								             #
# This script was made by combining Matt Riffle's Flexbook and               #
# Cliff Gdansk's Guestbook scripts.                                          #
# It allows for easy modification and easy administration.                   #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header or any of the parts that give me credit for writing     #
# this.  By using this script you agree to indemnify me from any liability   #
# that might arise from its use.  In simple English, if this script somehow  #
# makes your computer run amuck and kill the pope, it's not my fault.        #
#                                                                            #
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################
 
print ("Content-type: text/html\n\n");

# Read in style and setup

&read;

sub read {

open (SETUP, "setup.db");
@setup = <SETUP>;
close(SETUP);
$setupline = ($setup[0]);
chomp($setupline);
($title,$background,$bgcolor,$textcolor,$linkcolor,$vlinkcolor,$alinkcolor,$homepage,$mailprogram,$datafile,$success,$adminemail,$reverseentries,$allow_html,$entriesperpage,$maxentries,$mail_you,$guesspass,$bwfilter,$nextview,$backview,$privview,$adminpassword,$uplook,$downlook,$requiredfields,$fontface) = split(/\|/, $setupline);
$entriesperpage = ($entriesperpage + 1);
@required = split /\s+/, $requiredfields;
}


# Get guestbook entries

open (DATA, "$datafile");
@data = reverse(<DATA>);
close(DATA);

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\|/&#124\;/g;
        $FORM{$name} = $value;
}

# Decide what to do

if ($FORM{'action'} eq "menu") { &menu; }
if ($FORM{'action'} eq "moddel") { &moddel; }
if ($FORM{'action'} eq "modify") { &modify; }
if ($FORM{'action'} eq "delete") { &delete; }
if ($FORM{'action'} eq "writesettings") { &writesettings; }
if ($FORM{'action'} eq "modheading") { &modheading; }
if ($FORM{'action'} eq "writehead") { &writehead; }
if ($FORM{'action'} eq "modentry") { &modentry; }
if ($FORM{'action'} eq "writeentry") { &writeentry; }
if ($FORM{'action'} eq "modfooter") { &modfooter; }
if ($FORM{'action'} eq "writefooter") { &writefooter; }
if ($FORM{'action'} eq "modifywords") { &modifywords; }
if ($FORM{'action'} eq "writewordlist") { &writewordlist; }
if ($FORM{'action'} eq "modifybanned") { &modifybanned; }
if ($FORM{'action'} eq "writebanned") { &writebanned; }
else { &getpwd; }

sub getpwd {
	print "<html><head><title>$title - Administration</title></head>";
	print "<body bgcolor=#FFFFFF text=#000000>";
	print "<h1>Administration</h1><hr width=\"400\" align=left>";
	print "<form method=\"POST\"><input type=\"hidden\" name=\"action\" value=\"menu\">\n";
	print "<br>Please enter your password:<br><input type=\"password\" name=\"password\">\n";
	print "<br><input type=\"submit\" value=\" Enter \"></form></body></html>\n";
}

sub menu {
        &checkpassword;

        print <<MENUHTML;

<html><head><title>$title - Guestbook - Administration Menu</title></head>
<h1>Guestbook Administration</h1>
<center><hr width="80%" align=left></center>
<form method="POST">
<input type="hidden" name="action" value="moddel">
<input type="hidden" name="password" value="$FORM{'password'}">
<table border=0 cellpadding=0 cellspacing=0 width=250>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Modify / Delete Entries</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Entry Number?</B>
<br>
<input type="text" name="entry" value="" size=17>
<br>
<input type="submit" value=" Modify "></form>
</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<p>
<form method="POST">
<input type="hidden" name="action" value="writesettings">
<input type="hidden" name="password" value="$FORM{'password'}">
<table border=0 cellpadding=0 cellspacing=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td valign=bottom colspan=5>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Change Settings</B></FONT>
</td>
</tr>
<tr>
<td valign=bottom colspan=2 width=50% bgcolor="#608098">
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>HTML Settings</B></FONT>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td valign=bottom colspan=2 width=50% bgcolor="#608098">
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Guestbook Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Website Title</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=title value="$title">
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Datafile</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=datafile value=$datafile>
</td>
</tr>
<tr bgcolor="#95A6C1">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Website URL</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=homepage value=$homepage>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Mail Program</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=mailprogram value=$mailprogram>
</td>
</tr>
<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Background URL</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=background value=$background>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Admin Email</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=adminemail value=$adminemail>
</td>
</tr>
<tr bgcolor="#95A6C1">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Background Color</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=bgcolor value=$bgcolor>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Success URL</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=success value=$success>
</td>
</tr>
<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Text Color</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=textcolor value=$textcolor>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Allow HTML</B></FONT>
</td>
<td align=right width=25%>
<select name="allow_html">
MENUHTML

if ($allow_html eq "1") { 
print "<option value=0>No<option value=1 selected>Yes</select></td></tr>\n"; 
} else { 
print "<option value=0 selected>No<option value=1>Yes</select></td></tr>\n"; 
}

print <<MENUHTML2;

<tr bgcolor="#95A6C1">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Link Color</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=linkcolor value=$linkcolor>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Mail on Entry</B></FONT>
</td>
<td align=right width=25%>
<select name="mail_you">
MENUHTML2

if ($mail_you eq "1") { 
print "<option value=0>No<option value=1 selected>Yes</select></td></tr>\n"; 
} else { 
print "<option value=0 selected>No<option value=1>Yes</select></td></tr>\n"; 
}

print <<MENUHTML3;

<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Visited Link Color</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=vlinkcolor value=$vlinkcolor>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Mail on Password Guess</B></FONT>
</td>
<td align=right width=25%>
<select name="guesspass">
MENUHTML3

if ($guesspass eq "1") { 
print "<option value=0>No<option value=1 selected>Yes</select></td></tr>\n"; 
} else { 
print "<option value=0 selected>No<option value=1>Yes</select></td></tr>\n"; 
}

print <<MENUHTML4;
<tr bgcolor="#95A6C1">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Active Link Color</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=alinkcolor value=$alinkcolor>
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Entry Order</B></FONT>
</td>
<td align=right width=25%>
<select name="reverseentries">
MENUHTML4

if ($reverseentries eq "1") { 
print "<option value=0>??? - 1<option value=1 selected>1 - ???</select></td></tr>\n"; 
} else { 
print "<option value=0 selected>??? - 1<option value=1>1 - ???</select></td></tr>\n"; 
}

print <<MENUHTML5;

<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Next Link</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=nextview value="$nextview">
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Entries per Page</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=entriesperpage value="$entriesperpage">
</td>
</tr>
<tr bgcolor="#95A6C1">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Back Link</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=backview value="$backview">
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Max No. of Entries</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=maxentries value="$maxentries">
</td>
</tr>
<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Private Link</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=privview value="$privview">
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Admin Password</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=adminpassword value="$adminpassword">
</td>
</tr>
<tr bgcolor="#95A6C1">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Up Entry Look</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=uplook value="$uplook">
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Bad Word Filter</B></FONT>
</td>
<td align=right width=25%>
<select name="bwfilter">
MENUHTML5

if ($bwfilter eq "1") { 
print "<option value=0>Off<option value=1 selected>On</select>\n"; 
} else { 
print "<option value=0 selected>Off<option value=1>On</select>\n"; 
}

print <<MENUHTML6;
</td>
</tr>
<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Down Entry Look</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=downlook value="$downlook">
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
</td>
<td width=25%>
</td>
</tr>
<tr bgcolor="#95A6C1">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>Font Face</B></FONT>
</td>
<td align=right width=25%>
<input size=22 type=text name=fontface value="$fontface">
</td>
<td width=3 bgcolor=#000000>
&nbsp;
</td>
<td width=25%>
</td>
<td width=25%>
</td>
</tr>
<tr bgcolor="#8098B0">
<td width=25%>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000000"><B>
Required Fields
<p>
<input type=checkbox value=name name=reqname
MENUHTML6

if ($requiredfields =~ /name/) {
        print " CHECKED> Name\n";
        } else {
        print "> Name\n";
        }

print "<br><input type=checkbox value=email name=reqemail";

if ($requiredfields =~ /email/) {
        print " CHECKED> Email\n";
        } else {
        print "> Email\n";
        }

print "<br><input type=checkbox value=url name=requrl";

if ($requiredfields =~ /url/) {
        print " CHECKED> URL\n";
        } else {
        print "> URL\n";
        }

print "<br><input type=checkbox value=comment name=reqcomment";

if ($requiredfields =~ /comment/) {
        print " CHECKED> Comment\n";
        } else {
        print "> Comment\n";
        }

print "</td><td><FONT SIZE=2 FACE=\"Verdana, Arial\" COLOR=#000000><B>
<p><input type=checkbox value=var1 name=reqvar1";

if ($requiredfields =~ /var1/) {
        print " CHECKED> Var1\n";
        } else {
        print "> Var1\n";
        }

print "<br><input type=checkbox value=var2 name=reqvar2";

if ($requiredfields =~ /var2/) {
        print " CHECKED> Var2\n";
        } else {
        print "> Var2\n";
        }

print "<br><input type=checkbox value=var3 name=reqvar3";

if ($requiredfields =~ /var3/) {
        print " CHECKED> Var3\n";
        } else {
        print "> Var3\n";
        }

print "<br><input type=checkbox value=var4 name=reqvar4";

if ($requiredfields =~ /var4/) {
        print " CHECKED> Var4\n";
        } else {
        print "> Var4\n";
        }

print "<br><input type=checkbox value=var5 name=reqvar5";

if ($requiredfields =~ /var5/) {
        print " CHECKED> Var5\n";
        } else {
        print "> Var5\n";
}

print "<br><input type=checkbox value=var6 name=reqvar6";

if ($requiredfields =~ /var6/) {
        print " CHECKED> Var6\n";
        } else {
        print "> Var6\n";
}

print <<MENUHTML7;
</b>
</font>
</td>
<td width=3 bgcolor=#000000>
</td>
<td width=25%>
</td>
<td width=25%>
</td>
</tr>
</table>
</td>
</tr>
</table>
<input type=Submit value=" Submit "><input type=Reset value=" Reset ">
</form>

<table border=0 cellspacing=0 cellpadding=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td colspan=3 valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Misc Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td width=50%>
<br>
<center>
<form method=POST>
<input type="hidden" name="action" value="modifywords">
<input type="submit" value=" Bad Word List ">
</form>
</td>
<td width=50%>
<br>
<center>
<form method=POST>
<input type="hidden" name="action" value="modifybanned">
<input type="submit" value=" Banned IPs ">
</form>
</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<p>
<table border=0 cellpadding=0 cellspacing=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td colspan=3 valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Layout Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td>
<br>
<center>
<form method="POST">
<input type="hidden" name="action" value="modheading">
<input type="hidden" name="password" value="$FORM{'password'}">
<input type="submit" value=" Heading Layout ">
</form>
</center>
</td>
<td>
<br>
<center>
<form method="POST">
<input type="hidden" name="action" value="modentry">
<input type="hidden" name="password" value="$FORM{'password'}">
<input type="submit" value=" Entry Layout ">
</form>
</center>
</td>
<td>
<br>
<center>
<form method="POST">
<input type="hidden" name="action" value="modfooter">
<input type="hidden" name="password" value="$FORM{'password'}">
<input type="submit" value=" Footer Layout ">
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
MENUHTML7

exit;
}

sub checkpassword {
 my($date,$min,$hour,$day,$month,$year,$weekday,$ampm,$zero,@weekdays,@months);
 (undef, $min, $hour, $day, $month, $year, $weekday) = localtime(time);
 @weekdays = ("Sunday","Monday","Tuesday","Wednesday", 
             "Thursday","Friday","Saturday");
 @months = ("January","February","March","April","May","June","July",
           "August","September","October","November","December");
 # Dates correct through 2097 :)
 if ($year > 97) { $year += 1900; } else { $year += 2000; }  
 # Fix Time
 if ($hour > 12) { $hour -= 12; $ampm = "PM"; } else { $ampm = "AM"; }
 if ($hour == 0) { $hour = 12; }
 if ($min < 10) { $zero = "0"; } else { $zero = ""; }
 $time = "$hour:$zero$min $ampm";
 $date = "$months[$month] $day, $year";

        if ($FORM{'password'} eq "") {
                print "<html><head><title>You need a password for that!</title></head>\n";
                print "I'm sorry, but you need the password to do that.</body></html>\n";
                exit;
        }
        elsif ($FORM{'password'} ne $adminpassword) {
                print "<html><head><title>$title - Administration - Bad password</title></head>\n";
                print "<body text=#000000 bgcolor=#ffffff>";
                print "<h1>Bad Password</h1><br>\n";
                print "The password you entered, $FORM{'password'}, is incorrect.\n";
                if (($guesspass eq "1") && $adminemail) {
                        print "The following information has been mailed to the owner\n";
                        print "of this Guestbook.<ul>\n";
                        print "<li>Date/Time: $date/$time\n";
                        print "<li>Domain: $ENV{'REMOTE_HOST'}\n";
                        print "<li>IP Address: $ENV{'REMOTE_ADDR'}";
                        print "<li>Password: $FORM{'password'}\n";
                        print "</ul></body></html>\n";
			open (MAIL, "|$mailprogram -oi -t $adminemail");
                        print MAIL "From: $adminemail\n";
                        print MAIL "Subject: Attempted hack\n\n";
                        print MAIL "Someone has tried to guess your password for your\n";
                        print MAIL "guestbook!  The following information was logged:\n";
                        print MAIL "* Date/Time: $date/$time\n";
                        print MAIL "* IP Address: $ENV{'REMOTE_ADDR'}\n";
                        print MAIL "* Domain: $ENV{'REMOTE_HOST'}\n";
                        print MAIL "* Password: $FORM{'password'}\n";
                        close (MAIL);
                }
                exit;
        }
}

sub moddel {
        &checkpassword;
	$num = ($FORM{'entry'} - 1);
	$line = ($data[$num]);
	chomp($line);
	($name,$private,$email,$url,$comment,$date,$time,$var1,$var2,$var3,$var4,$var5,$var6,$ip,$browser) = split(/\|/, $line);
        print "<html><head><title>$title - Administration - Modify / Delete Entries</title></head>\n";
        print "<body text=#000000 bgcolor=#ffffff>";
	print "<h1>Modify / Delete Entry</h1><hr width=\"400\" align=left>";
	print "<form method=\"POST\"><input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
	print "<input type=\"hidden\" name=\"num\" value=\"$num\">\n";
	print "<center><table border=\"5\" width=\"500\"><tr><td>\n";
	print "<div align=right>Entry Number: <b>$FORM{'entry'}</b>\&nbsp;\&nbsp;</div>\n";
	print "<table><tr><td width=25% align=\"right\">Name:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"name\" size=\"35\" value=\"$name\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">E-mail:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"email\" size=\"35\" value=\"$email\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Web Page URL:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"url\" size=\"35\" value=\"$url\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Comments:</td>\n";
	print "<td width=75%><textarea name=\"comment\" rows=\"5\" cols=\"30\" wrap=\"soft\">$comment</textarea></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Date:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"date\" value=\"$date\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Time:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"time\" value=\"$time\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">IP Addr:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"ip\" size=\"35\" value=\"$ip\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Browser:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"browser\" size=\"35\" value=\"$browser\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Var1:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"var1\" size=\"35\" value=\"$var1\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Var2:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"var2\" size=\"35\" value=\"$var2\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Var3:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"var3\" size=\"35\" value=\"$var3\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Var4:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"var4\" size=\"35\" value=\"$var4\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Var5:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"var5\" size=\"35\" value=\"$var5\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Var6:</td>\n";
	print "<td width=75%><input type=\"text\" name=\"var6\" size=\"35\" value=\"$var6\"></td></tr>\n";
	print "<tr><td width=25% align=\"right\">Private Message?</td>\n";
	
	if ($private eq "priv") {
		print "<td width=75%><input type=checkbox name=private value=priv checked></td></tr>\n";
	} else{
		print "<td width=75%><input type=checkbox name=private value=priv></td></tr>\n";
	}
	print "<tr><td width=25% align=\"right\">What should I do?</td>\n";
	print "<td width=75%><input checked type=\"radio\" name=\"action\" value=\"modify\">Modify this entry<br>\n";
	print "<input type=\"radio\" name=\"action\" value=\"delete\">Delete this entry<br>\n";
	print "<input type=\"radio\" name=\"action\" value=\"menu\">Nothing</td></tr>\n";
	print "<tr><td width=25% align=\"right\"><input type=\"submit\" value=\" Do it! \"></td>\n";
	print "<td width=75%><input type=\"reset\"></td></tr></table></td></tr></table></form></body></html>";
	exit;
}

sub modify {
        &checkpassword;
        $line = "$FORM{'name'}|$FORM{'private'}|$FORM{'email'}|$FORM{'url'}|$FORM{'comment'}|$FORM{'date'}|$FORM{'time'}|$FORM{'var1'}|$FORM{'var2'}|$FORM{'var3'}|$FORM{'var4'}|$FORM{'var5'}|$FORM{'var6'}|$FORM{'ip'}|$FORM{'browser'}\n";
        splice(@data,$FORM{'num'},1,($line));
        &writedata;
        print "<html><head><title>Entry Modified</title></head>\n";
        print "<body text=#000000 bgcolor=#ffffff>";
        print "<h1>Entry Modified</h1>The entry has been modified.";
        print "<p><form method=\"POST\"><input type=\"hidden\"";
        print " name=\"action\" value=\"menu\"><input type=\"hidden\"";
        print " name=\"password\" value=\"$FORM{'password'}\">\n";
        print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
        print "</body></html>\n";
        exit;
}

sub delete {
        &checkpassword;
        splice(@data,$FORM{'num'},1,());
        &writedata;
        print "<html><head><title>Entry Deleted</title></head>\n";
        print "<body text=#000000 bgcolor=#ffffff>";
        print "<h1>Entry Deleted</h1>The entry has been deleted.";
        print "<p><form method=\"POST\"><input type=\"hidden\"name=\"action\" value=\"menu\">\n";
        print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
        print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
        print "</body></html>\n";
        exit;
}

sub writedata {

	@data = reverse(@data);
        open (FILE,">$datafile");
        foreach $line(@data) { 
        print FILE "$line"; 
        }
	close(FILE);
	@data = reverse(@data);
}

sub writesettings {

	$FORM{'entriesperpage'} = ($FORM{'entriesperpage'} - 1);

        $settingsline = "$FORM{'title'}|$FORM{'background'}|$FORM{'bgcolor'}|$FORM{'textcolor'}|$FORM{'linkcolor'}|$FORM{'vlinkcolor'}|$FORM{'alinkcolor'}|$FORM{'homepage'}|$FORM{'mailprogram'}|$FORM{'datafile'}|$FORM{'success'}|$FORM{'adminemail'}|$FORM{'reverseentries'}|$FORM{'allow_html'}|$FORM{'entriesperpage'}|$FORM{'maxentries'}|$FORM{'mail_you'}|$FORM{'guesspass'}|$FORM{'bwfilter'}|$FORM{'nextview'}|$FORM{'backview'}|$FORM{'privview'}|$FORM{'adminpassword'}|$FORM{'uplook'}|$FORM{'downlook'}|$FORM{'reqname'} $FORM{'reqemail'} $FORM{'requrl'} $FORM{'reqcomment'} $FORM{'reqvar1'} $FORM{'reqvar2'} $FORM{'reqvar3'} $FORM{'reqvar4'} $FORM{'reqvar5'} $FORM{'reqvar6'}|$FORM{'fontface'}\n";
	open (SETINGS, ">setup.db");
	print SETINGS "$settingsline";
	close(SETINGS);
	&read;
        print "<html><head><title>Settings Changed</title></head>\n";
        print "<body text=#000000 bgcolor=#ffffff>";
        print "<h1>Settings Changed</h1>The settings have been changed.";

	if ($FORM{'adminpassword'} ne $FORM{'password'}) {
	print "<p>Please write down your new password:<br>";
	print "<b>$adminpassword</b>";
	}

        print "<p><form method=\"POST\"><input type=\"hidden\"name=\"action\" value=\"menu\">\n";
        print "<input type=\"hidden\" name=\"password\" value=\"$adminpassword\">\n";
        print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
        print "</body></html>\n";
	exit;
}

sub modheading {

open (HEAD, "header.txt");
while (<HEAD>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@header,$_);
}
close(HEAD);

print <<MODHEAD;
<html><head><title>$title - Guestbook - Change Heading Layout</title></head>
<h1>Change Heading Layout</h1>
<center><hr width="80%" align=left></center>
<form method="POST">
<input type="hidden" name="action" value="writehead">
<input type="hidden" name="password" value="$FORM{'password'}">
<table border=0 cellpadding=0 cellspacing=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Layout Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#608098">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Header Layout</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td>
<center>
<textarea name=heading cols=90 rows=15>
@header
</textarea>
<br>
               <select name=aaaa>
                <option value="">------ ACTIVE HEADING TAGS ------</option>
                <option value="">[title] - Website Title</option>
                <option value="">[homepage] - Website Homepage</option>
                <option value="">[bgcolor] - Background Color</option>      
		<option value="">[font] - Font Face</option>
                <option value="">[textcolor] - Text Color</option>
                <option value="">[linkcolor] - Link Color</option>
                <option value="">[vlinkcolor] - Visited Link Color</option>
                <option value="">[alinkcolor] - Active Link Color</option>
                <option value="">[background] - Background Image</option>
                <option value="">[htmlstatus] - HTML Status (on or off)</option>
                <option value="">[totalnum] - Total Number of Entries</option>
                <option value="">[startnum] - Starting Number</option>
                <option value="">[endnum] - Ending Number</option>

               </select>
<input type="submit" value=" Save Changes ">
<input type="reset">
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<center>
<form method="POST"><input type="hidden" name="action" value="menu">
<input type="hidden" name="password" value="$adminpassword">
<input type="submit" value=" Back to Menu "></form>
</center>
</body>
</html>
MODHEAD
exit;
}

sub modentry {

open (ENTRY, "entry.txt");
while (<ENTRY>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@entry,$_);
}
close(ENTRY);

print <<MODENTRY;
<html><head><title>$title - Guestbook - Change Entry Layout</title></head>
<h1>Change Entry Layout</h1>
<center><hr width="80%" align=left></center>
<form method="POST">
<input type="hidden" name="action" value="writeentry">
<input type="hidden" name="password" value="$FORM{'password'}">
<table border=0 cellpadding=0 cellspacing=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Layout Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#608098">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Entry Layout</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td>
<center>
<textarea name=entry cols=90 rows=15>
@entry
</textarea>
<br>
               <select name=aaaa>
                <option value="">------ ACTIVE ENTRY TAGS ------</option>
                <option value="">[name] - Name</option>
                <option value="">[url] - Website URL</option>
                <option value="">[email] - Email Address</option>
                <option value="">[up] - Up 1 Entry</option>
                <option value="">[down] - Down 1 Entry</option>
                <option value="">[entrynum] - Entry Number</option>
                <option value="">[comment] - Comment</option>
		<option value="">[ip] - IP Address</option>
		<option value="">[browser] - Browser Name</option>
		<option value="">[var1] - Variable 1</option>
		<option value="">[var2] - Variable 2</option>
		<option value="">[var3] - Variable 3</option>
		<option value="">[var4] - Variable 4</option>
		<option value="">[var5] - Variable 5</option>
		<option value="">[var6] - Variable 6</option>
                <option value="">[date] - Entry Date</option>
                <option value="">[time] - Entry Time</option>
		<option value="">[font] - Font Face</option>
               </select>
<input type="submit" value=" Save Changes ">
<input type="reset">
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<center>
<form method="POST"><input type="hidden" name="action" value="menu">
<input type="hidden" name="password" value="$adminpassword">
<input type="submit" value=" Back to Menu "></form>
</center>
</body>
</html>
MODENTRY
exit;
}

sub modfooter {

open (FOOTER, "footer.txt");
while (<FOOTER>) {
	$_ =~ s/</&#60\;/ig;
	$_ =~ s/>/&#62\;/ig;
push (@footer,$_);
}
close(FOOTER);

print <<MODFOOTER;
<html><head><title>$title - Guestbook - Change Footer Layout</title></head>
<h1>Change Footer Layout</h1>
<center><hr width="80%" align=left></center>
<form method="POST">
<input type="hidden" name="action" value="writefooter">
<input type="hidden" name="password" value="$FORM{'password'}">
<table border=0 cellpadding=0 cellspacing=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Layout Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#608098">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Footer Layout</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td>
<center>
<textarea name=footer cols=90 rows=15>
@footer
</textarea>
<br>
               <select name=aaaa>
                <option value="">------ ACTIVE FOOTER TAGS ------</option>
		<option value="">[font] - Font Face</option>
               </select>
<input type="submit" value=" Save Changes ">
<input type="reset">
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<center>
<form method="POST"><input type="hidden" name="action" value="menu">
<input type="hidden" name="password" value="$adminpassword">
<input type="submit" value=" Back to Menu "></form>
</center>
</body>
</html>
MODFOOTER
exit;
}

sub writehead {

&checkpassword;

$FORM{'heading'} =~ s/&#60\;/</g;
$FORM{'heading'} =~ s/&#62\;/>/g;

@Newheading = $FORM{'heading'};

open (WRITEHEAD,">header.txt");
        foreach $Newheading (@Newheading) {
                print WRITEHEAD "$Newheading\n";
        }
close(WRITEHEAD);

print "<html><head><title>Heading HTML Changed</title></head>\n";
print "<body text=#000000 bgcolor=#ffffff>";
print "<h1>Heading HTML Changed</h1>The heading HTML has been changed.";
print "<p><form method=\"POST\"><input type=\"hidden\"name=\"action\" value=\"menu\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
print "</body></html>\n";
exit;

}

sub writeentry {

&checkpassword;

$FORM{'entry'} =~ s/&#60\;/</g;
$FORM{'entry'} =~ s/&#62\;/>/g;

@Newentry = $FORM{'entry'};

open (WRITEENTRY,">entry.txt");
        foreach $Newentry (@Newentry) {
                print WRITEENTRY "$Newentry\n";
        }
close(WRITEENTRY);

print "<html><head><title>Entry HTML Changed</title></head>\n";
print "<body text=#000000 bgcolor=#ffffff>";
print "<h1>Entry HTML Changed</h1>The Entry HTML has been changed.";
print "<p><form method=\"POST\"><input type=\"hidden\"name=\"action\" value=\"menu\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
print "</body></html>\n";
exit;

}

sub writefooter {

&checkpassword;

$FORM{'footer'} =~ s/&#60\;/</g;
$FORM{'footer'} =~ s/&#62\;/>/g;

# Split the header into seperate lines

@Newfooter = $FORM{'footer'};

open (WRITEFOOTER,">footer.txt");
        foreach $Newfooter (@Newfooter) {
                print WRITEFOOTER "$Newfooter\n";
        }
close(WRITEFOOTER);

print "<html><head><title>Footer HTML Changed</title></head>\n";
print "<body text=#000000 bgcolor=#ffffff>";
print "<h1>Footer HTML Changed</h1>The Footer HTML has been changed.";
print "<p><form method=\"POST\"><input type=\"hidden\"name=\"action\" value=\"menu\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$FORM{'password'}\">\n";
print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
print "</body></html>\n";
exit;

}

sub modifywords {

open (WORDS, "badwords.txt");
@badwords = <WORDS>;
close(WORDS);

print <<FORMHTML;
<html><head><title>$title - Guestbook - Change Badword List</title></head>
<h1>Change Badword List</h1>
<center><hr width="80%" align=left></center>
<form method="POST">
<input type="hidden" name="action" value="writewordlist">
<input type="hidden" name="password" value="$FORM{'password'}">
<table border=0 cellpadding=0 cellspacing=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#608098">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Badwords List</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td>
<center>
<textarea name=words cols=90 rows=6 wrap="soft">
@badwords
</textarea>
<input type="submit" value=" Save Changes ">
<input type="reset">
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<center>
<form method="POST"><input type="hidden" name="action" value="menu">
<input type="hidden" name="password" value="$adminpassword">
<input type="submit" value=" Back to Menu "></form>
</center>
</body>
</html>
FORMHTML
exit;
}

sub writewordlist {

@badwords = split /\s+/, $FORM{'words'};

open (WORDS, ">badwords.txt");
print WORDS "@badwords";
close(WORDS);

print "<html><head><title>Settings Changed - Bad Word List Updated</title></head>\n";
print "<body text=#000000 bgcolor=#ffffff>";
print "<h1>Bad Word List Updated</h1>";
print "<p><form method=\"POST\"><input type=\"hidden\"name=\"action\" value=\"menu\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$adminpassword\">\n";
print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
print "</body></html>\n";
exit;
}

sub modifybanned {

open (BANNEDIP, "banned.txt");
@bannedip = split /\s+/, <BANNEDIP>;
close(BANNEDIP);

print <<FORMHTML;
<html><head><title>$title - Guestbook - Change Banned IP List</title></head>
<h1>Change Badword List</h1>
<center><hr width="80%" align=left></center>
<form method="POST">
<input type="hidden" name="action" value="writebanned">
<input type="hidden" name="password" value="$FORM{'password'}">
<table border=0 cellpadding=0 cellspacing=0 width=98%>
<TR>
<td bgcolor="#000000">
<table border=0 cellspacing=1 width=100%>
<tr bgcolor="#506880">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Settings</B></FONT>
</td>
</tr>
<tr bgcolor="#608098">
<td valign=bottom>
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FFFFFF"><B>Banned IPs</B></FONT>
</td>
</tr>
<tr bgcolor="#8098B0">
<td>
<center>
<textarea name=ips cols=90 rows=6 wrap="soft">
@bannedip
</textarea>
<input type="submit" value=" Save Changes ">
<input type="reset">
</form>
</center>
</td>
</tr>
</table>
</td>
</tr>
</table>
<p>
<center>
<form method="POST"><input type="hidden" name="action" value="menu">
<input type="hidden" name="password" value="$adminpassword">
<input type="submit" value=" Back to Menu "></form>
</center>
</body>
</html>
FORMHTML
exit;
}

sub writebanned {

@banned = split /\s+/, $FORM{'ips'};

open (BANNED, ">banned.txt");
print BANNED "@banned";
close(BANNED);

print "<html><head><title>Settings Changed - Banned IPs Updated</title></head>\n";
print "<body text=#000000 bgcolor=#ffffff>";
print "<h1>Banned IP List Updated</h1>";
print "<p><form method=\"POST\"><input type=\"hidden\"name=\"action\" value=\"menu\">\n";
print "<input type=\"hidden\" name=\"password\" value=\"$adminpassword\">\n";
print "<input type=\"submit\" value=\" Back to Menu \"></form>\n";
print "</body></html>\n";
exit;
}
