#!/usr/bin/perl
##############################################################################
# Megabook - Guestbook SIGNING Script V1.1                                   # 
# Copyright 2000 Terry Billinger                                             #
# Created 7/3/00                                                             #
# Available at http://www.militerry.com/megabook/                            #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 2000 Terry Billinger                                             #
#    								             #
# This script was made by combining Matt Riffle's Flexbook and               #
# Cliff Gdansk's Guestbook scripts.                                          #
# It allows for easy modification and easy administration.                   #
#                                                                            #
# This script can be used\modified free of charge as long as you don't       #
# change this header or any of the parts that give me credit for writing     #
# this.  By using this script you agree to indemnify me from any liability   #
# that might arise from its use.  In simple English, if this script somehow  #
# makes your computer run amuck and kill the pope, it's not my fault.        #
#                                                                            #
#                                                                            #
# Redistributing\selling the code for this program without prior written     #
# consent is expressly forbidden.                                            #
##############################################################################

# This array contains the form fields that must be filled in before the# entry can be added.  Set it to ("") if no particular form field *has*# to be entered.@required = ("name", "comment");# If you place "bad words" in this array, the guestbook will# replace occurrences of them with ****.  This, to some degree, helps# keep foul language out of your guestbook.  Comment it out if you don't# want any filtering.# @badwords = ("gosh","heck","shucks","darn");

# Adds in style and setup.

open (SETUP, "setup.db");
@setup = <SETUP>;
close(SETUP);
$setupline = ($setup[0]);
chomp($setupline);
($title,$background,$bgcolor,$textcolor,$linkcolor,$vlinkcolor,$alinkcolor,$homepage,$mailprogram,$datafile,$success,$adminemail,$reverseentries,$allow_html,$entriesperpage,$maxentries,$mail_you,$guesspass,$bwfilter,$nextview,$backview,$privview,$adminpassword,$uplook,$downlook,$requiredfields,$fontface) = split(/\|/, $setupline);

# Get guetsbook entries

open (DATA, "$datafile");
@data = <DATA>;
close(DATA);

open (BANNEDIP, "banned.txt");
@bannedip = split /\s+/, <BANNEDIP>;
close(BANNEDIP);

foreach $ip (@bannedip) {
  if ($ip eq "$ENV{'REMOTE_ADDR'}") {

  print ("Content-type: text/html\n\n");
  print "<html><title>BANNED IP</title><body bgcolor=#FFFFFF text=#000000>\n";
  print "<h1>IP BANNED</h1>\n";
  print "<p>We're sorry but this IP has been banned.  Please contact\n";
  print "the guestbook administrator if you believe this is an error.\n";
  print "</body></html>";
  exit;
  }
}


# Organize Input
&parse_form;

# Check Required Fields
&check_for_required;

# Add Entry
&add_entry;

# Mail Admin if Needed
if (($mail_you) && ($adminemail)) {
  &mail_admin;
}
# Report Success
&report_success;

# Get the submitted data

sub parse_form {

# Die if method is "GET"
 if ($ENV{'QUERY_METHOD'} eq "GET") {
   &error("GET");
 }

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
        ($name, $value) = split(/=/, $pair);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\|/&#124\;/g;

        $value =~ s/</&#60;/g;
        $value =~ s/>/&#62;/g;

	# Check for line feeds
 
	$value =~ s/\n\r\n/<p>/sg;
	$value =~ s/\n\n/<p>/sg;
	$value =~ s/\n/<br>/sg;
	$value =~ s/\r//sg;

        $value =~ s/\s/ /g;
        $FORM{$name} = $value;
        }
}

sub check_for_required {

@required = split /\s+/, $requiredfields;

 if (@required) {
   foreach $req (@required) {
     if (!$FORM{$req}) { push (@missing,$req); }
   }
 }
 if (@missing) { &errormissing; }
}

sub add_entry {

 # Create Date Stamp
 my($date,$min,$hour,$day,$month,$year,$weekday,$ampm,$zero,@weekdays,@months);
 (undef, $min, $hour, $day, $month, $year, $weekday) = localtime(time);
 @weekdays = ("Sunday","Monday","Tuesday","Wednesday", 
             "Thursday","Friday","Saturday");
 @months = ("January","February","March","April","May","June","July",
           "August","September","October","November","December");
 # Dates correct through 2097 :)
 if ($year > 97) { $year += 1900; } else { $year += 2000; }  
 # Fix Time
 if ($hour > 12) { $hour -= 12; $ampm = "PM"; } else { $ampm = "AM"; }
 if ($hour == 0) { $hour = 12; }
 if ($min < 10) { $zero = "0"; } else { $zero = ""; }
 $time = "$hour:$zero$min $ampm";
 $date = "$months[$month] $day, $year";

# Write Data to File
	
        splice (@data,0,0,"$FORM{'name'}|$FORM{'private'}|$FORM{'email'}|$FORM{'url'}|$FORM{'comment'}|$date|$time|$FORM{'var1'}|$FORM{'var2'}|$FORM{'var3'}|$FORM{'var4'}|$FORM{'var5'}|$FORM{'var6'}|$ENV{'REMOTE_ADDR'}|$ENV{'HTTP_USER_AGENT'}\n");
        unless ($maxentries <= 0) { while ($#data > $maxentries) { splice(@data,$#data,1); } }
        open (FILE,">$datafile");
        foreach $line(@data) { 
        print FILE "$line"; 
        }
	close(FILE)
}

sub mail_admin {

 open (MAIL, "|$mailprogram -oi -t $adminemail") || &error("MAIL");
 print MAIL "From: $adminemail\n";
 print MAIL "Subject: Guestbook Entry\n\n";
 print MAIL "The following entry was added to the guestbook:\n\n";
 print MAIL "* Name: $FORM{'name'}\n";
 print MAIL "* Email: $FORM{'email'}\n";
 print MAIL "* URL: $FORM{'url'}\n";
 print MAIL "* Comments: $FORM{'comment'}\n";
 close (MAIL);
}

sub report_success {
 if ($success) {
  print "Location: $success \n\n";
 } else {
  print ("Content-type: text/html\n\n");
  print "<html><body bgcolor='#ffffff'>\n";
  print "<h1>Thank you for adding to the guestbook!</h1>";
  print "Use your back button to return, and reload to see your entry";
  print "</body></html>\n";
 }
 exit;
}

#Error Messages

sub error {
  my %ERR;
  $ERR{"GET"} = "The script must be called with the POST method.";
  $ERR{"MAIL"} = "An error occurred while sending mail to the site
     administrator.  If this persists, please let them know.";
  my $emsg = $ERR{$_[0]};
  if (!$emsg) {
    $emsg = "The script has suffered an unknown error.";
  }
  print ("Content-type: text/html\n\n");
  print "<html><body bgcolor=#FFFFFF text=#000000>\n";
  print "<h1>Guestbook Error</h1>\n";
  print "$emsg";
  print "</body></html>";
  exit;
}

sub errormissing {

     print ("Content-type: text/html\n\n");
     print "<html><title>Guestbook Error - Required Fields Missing</title>";
     print "<body bgcolor=\"$bgcolor\" background=\"$background\" text=\"$textcolor\" link=\"$linkcolor\" vlink=\"$vlinkcolor\" alink=\"$alinkcolor\">\n";
     print "<h1>Guestbook Error</h1>\n";
     print "The following required fields were not filled out:<p>\n";
     print "<ul>\n";
     foreach $req(@missing) {
         print "<li>$req</li>\n";
         }
     print "</ul>\n";
     exit;
}